"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var stores_1 = require("../stores");
var isArray = require('lodash/isArray');
var isPlainObject = require('lodash/isPlainObject');
function handleArrayValue(field, value) {
    if (value && !isArray(value)) {
        throw new Error('Expected initialValues for array field to be an array');
    }
    field.setInitialValues(value);
}
function handleObjectValue(field, value) {
    if (value && !isPlainObject(value)) {
        throw new Error('Expected initialValues for object field to be an object');
    }
    field.setInitialValues(value);
}
function setInitialValuesFor(field, value) {
    if (field instanceof stores_1.ArrayStore) {
        handleArrayValue(field, value);
    }
    else if (field instanceof stores_1.ObjectStore) {
        handleObjectValue(field, value);
    }
    else {
        field.setInitialValues(value);
    }
}
exports.default = setInitialValuesFor;
;
//# sourceMappingURL=setInitialValuesFor.js.map