import { IMap, IObjectErrors } from '../types';
import { ChildStore, ParentStore } from './types';
import { IObservableArray, ObservableMap } from 'mobx';
export declare class ObjectStore {
    parent: ParentStore;
    fields: ObservableMap<ChildStore>;
    protected initialValues: IMap;
    private fieldErrors;
    readonly value: IMap;
    registerField(name: string, field: ChildStore): void;
    unregisterField(name: string): void;
    setInitialValues(initialValues?: IMap): void;
    readonly errors: IObservableArray<string>;
    clearErrors(): void;
    setErrors(errors: IObjectErrors): void;
}
