import { FormStore } from '../../stores';
import { IMap, IStringMap } from '../../types';
import { ComponentClass, FormEvent } from 'react';
import * as React from 'react';
export interface IOnSubmit {
    (form: IStringMap, ...otherArgs: any[]): any;
}
export interface IWrappedOnSubmit {
    (e: FormEvent<any>, ...otherArgs: any[]): void;
}
export interface IFormOptions<Props> {
    initialValues: IMap | ((props: Props) => IMap) | undefined;
    onSubmit: IOnSubmit;
}
export declare type IWithFormPropsParamProps = {
    __formobx: {
        onSubmit: IWrappedOnSubmit;
        store: FormStore;
    };
};
export declare function createWithFormProps<Props>(options: IFormOptions<Props>): (WrappedComponent: ComponentClass<Props & IWithFormPropsParamProps> | React.StatelessComponent<Props & IWithFormPropsParamProps>) => ComponentClass<Props>;
