"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var stores_1 = require("../../stores");
var react_1 = require("react");
var React = require("react");
;
function wrapOnSubmit(store, callback) {
    return function (e) {
        var otherArgs = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            otherArgs[_i - 1] = arguments[_i];
        }
        e.preventDefault();
        store.setSubmitting(true);
        store.clearErrors();
        Promise.resolve(callback.apply(void 0, [store.value].concat(otherArgs)))
            .catch(function (result) { return store.setErrors(result); })
            .then(function () { return store.setSubmitting(false); });
    };
}
function createWithFormProps(options) {
    return function withFormProps(WrappedComponent) {
        return (function (_super) {
            __extends(class_1, _super);
            function class_1(props) {
                var _this = _super.call(this, props) || this;
                var componentOptions = __assign({}, options);
                if (typeof componentOptions.initialValues === 'function') {
                    componentOptions.initialValues = componentOptions.initialValues(props);
                }
                _this.store = new stores_1.FormStore(componentOptions);
                if (componentOptions.onSubmit) {
                    _this.onSubmit = wrapOnSubmit(_this.store, componentOptions.onSubmit);
                }
                return _this;
            }
            class_1.prototype.render = function () {
                var formobxProps = {
                    onSubmit: this.onSubmit,
                    store: this.store
                };
                return (React.createElement(WrappedComponent, __assign({}, this.props, { __formobx: formobxProps })));
            };
            return class_1;
        }(react_1.Component));
    };
}
exports.createWithFormProps = createWithFormProps;
//# sourceMappingURL=createWithFormProps.js.map