"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var stores_1 = require("../stores");
var react_1 = require("react");
var React = require("react");
function withFieldsRegistered(WrappedComponent) {
    return (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.fields = [];
            return _this;
        }
        class_1.prototype.componentDidMount = function () {
            var parentStore = this.props.__formobx.parentStore;
            if (parentStore instanceof stores_1.ArrayStore) {
                this.fields.forEach(function (data) {
                    parentStore.registerField(data.field);
                });
            }
            else {
                if (this.fields.length === 0 || this.fields.some(function (data) { return !data.name; })) {
                    throw new Error('All fields must have names when the parent is not an ArrayField');
                }
                this.fields.forEach(function (data) {
                    parentStore.registerField(data.name, data.field);
                });
            }
        };
        class_1.prototype.componentWillUnmount = function () {
            var parentStore = this.props.__formobx.parentStore;
            if (parentStore instanceof stores_1.ArrayStore) {
                this.fields.forEach(function (data) {
                    parentStore.unregisterField(data.field);
                });
            }
            else {
                if (this.fields.length === 0) {
                    throw new Error('Names are required when the parent is not an ArrayField');
                }
                this.fields.forEach(function (data) {
                    parentStore.unregisterField(data.name);
                });
            }
        };
        class_1.prototype.render = function () {
            var formobxProps = __assign({}, this.props.__formobx, { fields: this.fields });
            return (React.createElement(WrappedComponent, __assign({}, this.props, { __formobx: formobxProps })));
        };
        return class_1;
    }(react_1.Component));
}
exports.withFieldsRegistered = withFieldsRegistered;
//# sourceMappingURL=withFieldsRegistered.js.map